﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace HighVoltz.AutoAngler
{
	static partial class Coroutines
	{
		private readonly static WaitTimer RecastTimer = WaitTimer.TenSeconds;

		private static List<Bait> _Baits;

		public class Bait
		{
			public uint ItemID;
			public uint ZoneID;
			public string Name;

			public Bait(uint itemID, uint zoneID, string name)
			{
				this.ItemID = itemID;
				this.ZoneID = zoneID;
				this.Name = name;
			}
		}

		// does nothing if no baits are in bag
		public async static Task<bool> ApplyBait()
		{
			if (StyxWoW.Me.IsCasting)
				return false;

			if (!RecastTimer.IsFinished)
				return false;

			RecastTimer.Reset();

			var item = Baits.Find(b => b.ZoneID == StyxWoW.Me.ZoneId);
			WoWItem baitInBag = Utility.GetItemInBag(item.ItemID);

			if (baitInBag != null && baitInBag.Use())
			{
				AutoAnglerBot.Log("Using {0}", item.Name);
				await CommonCoroutines.SleepForLagDuration();
			}

			return true;
		}

		public static List<Bait> Baits {
			get
			{
				if (_Baits == null)
				{
					_Baits = new List<Bait>();
					_Baits.Add(new Bait(110274, 6721, "Jawless Skulker Bait"));
					_Baits.Add(new Bait(110289, 6755, "Fat Sleeper Bait"));
					_Baits.Add(new Bait(110290, 6719, "Blind Lake Sturgeon Bait"));
					_Baits.Add(new Bait(110291, 6721, "Fire Ammonite Bait"));
					_Baits.Add(new Bait(110293, 6722, "Abyssal Gulper Eel Bait"));
					_Baits.Add(new Bait(110294, 6719, "Blackwater Whiptail Bait"));
				}
				return _Baits;
			}
		}
	}
}
